// KKJSetup v0.8a by N's LAB Copyright (C) 2006-2007 by Nobumichi Kozawa
package setup;

import javax.microedition.lcdui.*;
import javax.microedition.midlet.MIDlet;
import javax.microedition.rms.*;

// KKJConfig format
// Byte 0 = Font Size, Kanji edit
//      1 = Font Size, special chracter panel
//          0 = Large, 1 = Mid, 2 = Small
//      2 = Automatic Text Save Option, 0 = Automatic Save, 1= No Save
//      3 bit 0x01 = Freedom mini + Nokia driver mode, 0x02 = Memory Load Dictionary
//      4 = User Dictionary, 0 = Not use, 1 = use
//		5 = TextBox menu item prohibition
//		6 = Kanji Input menu item prohibition
//		7 = Input Mode item prohibition
//      8 = E61 Keytop
//      9 = List Conversion Mode count
//	
// KKJShortCut
// int 0 iSpChr = k0;
//     1 iKJModeKey = k1;
//     2 iModeKey = k2;
//     3 iInsKey = k3;
//     4 iAddKey = k4;
//     5 iCopyKey = k5;

// LEMOD
public class KKJSetup extends MIDlet implements CommandListener //, ItemCommandListener
{
    private Command exitCommand, canCommand, udicCommand, scCommand, scDefCommand;
    private Display disp;
    private List mainList;
    private FontSel fsel;
    private TextSave ts;
    private OtherSel osel;
// LECMTS
/*
    private UserDict udic;
    private KFileDialogClass kfd;
*/
// LECMTE
    private TbMenu tbmenu;
    private KjMenu kjmenu;
    private IModeMenu imode;
// LECMTS
/*
    private E61KeyTop e61key;
	private ShortCut sc;
	private KKeyEdit kke;
    public boolean bE61;
*/
// LECMTE
    public byte bKJFont, bSPFont, bTextSave, bOtherFlag, bUserDict;
    public byte bTbMenuItem, bKjMenuItem, bIMode, bE61key, bListConv;
    public String sUserDictPath;
    public int iSpChr, iInsKey, iAddKey, iCopyKey, iModeKey, iKJModeKey;
    
    public KKJSetup() {
    	disp = Display.getDisplay(this);
		String[] stringArray;
// LECMTS
/*
    	String sPlatform = System.getProperty("microedition.platform");
    	//sPlatform = "NokiaE61-1/0618.04.04";
        bE61 = sPlatform.startsWith("NokiaE61");

		if (bE61) {
	        stringArray = new String[]{
    	        "tHg", 
        	    "eLXgۊ",
            	"[U[",
	            "Rsyʃj[",
    	        "͉ʃj[",
        	    "",
        	    "V[gJbg",
            	"̑̐ݒ",
            	"E61L[CAEg"
        	};
        } else {
*/
// LECMTE
	        stringArray = new String[]{
    	        "tHg", 
        	    "eLXgۊ",
// LECMTS
/*
            	"[U[",
*/
// LECMTE
	            "Rsyʃj[",
    	        "͉ʃj[",
        	    "",
// LECMTS
/*
        	    "V[gJbg",
*/
// LECMTE
            	"̑̐ݒ",
        	};
// LECMTS
/*
        }
*/
// LECMTE
        Image[] imageArray = null;

        mainList = new List("KKJConvݒ", Choice.IMPLICIT, stringArray, imageArray);
        exitCommand = new Command("ۊ", Command.EXIT, 1);
        canCommand = new Command("LZ", Command.CANCEL, 1);
        mainList.addCommand(exitCommand);
        mainList.addCommand(canCommand);
        mainList.setCommandListener(this);

    	fsel = new FontSel();
    	fsel.fontForm.addCommand(exitCommand);
    	fsel.fontForm.addCommand(canCommand);
    	fsel.fontForm.setCommandListener(this);
    	
    	ts = new TextSave();
    	ts.textForm.addCommand(exitCommand);
    	ts.textForm.addCommand(canCommand);
    	ts.textForm.setCommandListener(this);

// LECMTS
/*
    	udic = new UserDict();
		udicCommand = new Command("t@CI", Command.ITEM, 1);
    	udic.udicForm.addCommand(exitCommand);
    	udic.udicForm.addCommand(canCommand);
		udic.siUdicPath.setDefaultCommand(udicCommand);
		udic.siUdicPath.setItemCommandListener(this);
    	udic.udicForm.setCommandListener(this);
*/
// LECMTE

    	osel = new OtherSel();
    	osel.otherForm.addCommand(exitCommand);
    	osel.otherForm.addCommand(canCommand);
    	osel.otherForm.setCommandListener(this);

		tbmenu = new TbMenu();
		tbmenu.tbForm.addCommand(exitCommand);
		tbmenu.tbForm.addCommand(canCommand);
		tbmenu.tbForm.setCommandListener(this);

		kjmenu = new KjMenu();
		kjmenu.kjForm.addCommand(exitCommand);
		kjmenu.kjForm.addCommand(canCommand);
		kjmenu.kjForm.setCommandListener(this);
		
		imode = new IModeMenu();
		imode.imForm.addCommand(exitCommand);
		imode.imForm.addCommand(canCommand);
		imode.imForm.setCommandListener(this);

// LECMTS
/*
		if (bE61) {
			e61key = new E61KeyTop();
    		e61key.e61Form.addCommand(exitCommand);
    		e61key.e61Form.addCommand(canCommand);
    		e61key.e61Form.setCommandListener(this);
    	} else e61key = null;

		sc = new ShortCut();
		scCommand = new Command("L[I", Command.ITEM, 1);
		scDefCommand = new Command("Kl", Command.ITEM, 2);
    	sc.scForm.addCommand(exitCommand);
    	sc.scForm.addCommand(canCommand);
    	sc.siSpChr.setDefaultCommand(scCommand);
    	sc.siSpChr.setItemCommandListener(this);
    	sc.siKanji.setDefaultCommand(scCommand);
    	sc.siKanji.setItemCommandListener(this);
    	sc.siMode.setDefaultCommand(scCommand);
    	sc.siMode.setItemCommandListener(this);
    	sc.siIns.setDefaultCommand(scCommand);
    	sc.siIns.setItemCommandListener(this);
    	sc.siAdd.setDefaultCommand(scCommand);
    	sc.siAdd.setItemCommandListener(this);
    	sc.siCopy.setDefaultCommand(scCommand);
    	sc.siCopy.setItemCommandListener(this);
    	sc.siDefault.setDefaultCommand(scDefCommand);
    	sc.siDefault.setItemCommandListener(this);
    	sc.scForm.setCommandListener(this);
*/
// LECMTE

		loadConfig();
// LECMTS
/*
		loadShortCut();
*/
// LECMTE
        disp.setCurrent(mainList);
    }
    
// LECMTS
/*
    private void loadShortCut() {
    	RecordStore rs = null;
    	byte[] ba;
    	
    	try {
    		rs = RecordStore.openRecordStore("KKJShortCut", false);
    		ba = rs.getRecord(1);
    		if (24 == ba.length) {
				iSpChr = ba2int(ba, 0);
				iKJModeKey = ba2int(ba, 1);
				iModeKey = ba2int(ba, 2);
				iInsKey = ba2int(ba, 3);
				iAddKey = ba2int(ba, 4);
				iCopyKey = ba2int(ba, 5);
    		} else {
	    		sc.setDefaultValue();
    		}
    		sc.refresh();
    	} catch (Exception e) {
    		sc.setDefaultValue();
    		sc.refresh();
    	} finally {
    		try {
    			if (null != rs) rs.closeRecordStore();
    		} catch (Exception e) {
    			e.printStackTrace();
    		}
    	}
    }
    
    private int ba2int(byte[] ba, int pos) {
    	int iWork = 0, offset = pos * 4;
		for (int i = offset + 3; i >= offset; i--) {
			iWork *= 128;
			iWork += ba[i];
		}
		return iWork;
    }
*/
// LECMTE
    
    private void loadConfig() {
    	RecordStore rsc = null, rsUdicPath = null;
    	byte[] ba;
    	
    	// Default set
    	bKJFont = bSPFont = bE61key = 1;
    	bOtherFlag = bTextSave = bUserDict = 0;
    	bListConv = 3;
    	sUserDictPath = "E:/KKJConv/KKJUser.dic";
    	
    	try {
    		rsc = RecordStore.openRecordStore("KKJConfig", false);
    		ba = rsc.getRecord(1);
    		switch (ba.length) {
    			case 10 : bListConv = ba[9];
    			case 9 : bE61key = ba[8];
    			case 8 : bIMode = ba[7];
    			case 7 : bKjMenuItem = ba[6];
    			case 6 : bTbMenuItem = ba[5];
    			case 5 : bUserDict = ba[4];
    			case 4 : bOtherFlag = ba[3];
    			case 3 : bTextSave = ba[2];
				case 2 : bSPFont = ba[1];
				case 1 : bKJFont = ba[0];
    		}
// LECMTS
/*
    		rsUdicPath = RecordStore.openRecordStore("KKJUdic", false);
    		ba = rsUdicPath.getRecord(1);
    		sUserDictPath = new String(ba, "UTF-8");
*/
// LECMTE
    	} catch (Exception e) {
    	} finally {
    		try {
    			if (null != rsc) rsc.closeRecordStore();
// LECMTS
/*
    			if (null != rsUdicPath) rsUdicPath.closeRecordStore();
*/
// LECMTE
    		} catch (Exception e) {
    			e.printStackTrace();
    		}
    	}
    }

// LECMTS
/*
	private void storeShortCut() {
		byte[] ba = new byte[24];

		int2ba(ba, 0, iSpChr);
		int2ba(ba, 1, iKJModeKey);
		int2ba(ba, 2, iModeKey);
		int2ba(ba, 3, iInsKey);
		int2ba(ba, 4, iAddKey);
		int2ba(ba, 5, iCopyKey);
		
		try {
			try {
				RecordStore.deleteRecordStore("KKJShortCut");
			} catch (RecordStoreNotFoundException e){
			}
			RecordStore rsc = RecordStore.openRecordStore("KKJShortCut", true);
			rsc.addRecord(ba, 0, ba.length);
			rsc.closeRecordStore();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	private void int2ba(byte[] ba, int pos, int val) {
		int iWork = val, offset = pos * 4;
		for (int i = offset; i < offset + 4; i++) {
			ba[i] = (byte)(iWork % 128);
			iWork /= 128;
		}
	}
*/
// LECMTE

	private void storeConfig() {
		byte[] ba = {
			bKJFont, bSPFont, bTextSave, bOtherFlag, bUserDict, bTbMenuItem, bKjMenuItem, bIMode, bE61key, bListConv
		};
		
		try {
			try {
				RecordStore.deleteRecordStore("KKJConfig");
			} catch (RecordStoreNotFoundException e){
			}
			RecordStore rsc = RecordStore.openRecordStore("KKJConfig", true);
			rsc.addRecord(ba, 0, ba.length);
			rsc.closeRecordStore();
// LECMTS
/*
			try {
				RecordStore.deleteRecordStore("KKJUdic");
			} catch (RecordStoreNotFoundException e){
			}
			rsc = RecordStore.openRecordStore("KKJUdic", true);
			ba = sUserDictPath.getBytes("UTF-8");
			rsc.addRecord(ba, 0, ba.length);
			rsc.closeRecordStore();
*/
// LECMTE
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	protected void startApp() {}
    protected void destroyApp(boolean unconditional) {}
    protected void pauseApp() {}

// LECMTS
/*
	public void commandAction(Command command, Item item) {
	    if (item.equals(udic.siUdicPath)) {
        	if (command == udicCommand) {
        		kfd = new KFileDialogClass("KKJUser.dicIۊǂĂB");
		    	kfd.fileList.addCommand(exitCommand);
    			kfd.fileList.addCommand(canCommand);
        		kfd.fileList.setCommandListener(this);
        		new Thread(new Runnable() {
        			public void run() {
        				kfd.openRoot();
        			}
        		}).start();
   				disp.setCurrent(kfd.fileList);
        	}
        } else if (command == scDefCommand) {
			sc.setDefault();
        } else if (command == scCommand) {
       		if (item.equals(sc.siSpChr)) {
       			sc.pos = 0;
       			kke = new KKeyEdit("Lpl");
         	} else if (item.equals(sc.siKanji)) {
         		sc.pos = 1;
   	    		kke = new KKeyEdit("[h");
        	} else if (item.equals(sc.siMode)) {
        		sc.pos = 2;
   	    		kke = new KKeyEdit("");
       		} else if (item.equals(sc.siIns)) {
       			sc.pos = 3;
       			kke = new KKeyEdit("}");
        	} else if (item.equals(sc.siAdd)) {
        		sc.pos = 4;
   	    		kke = new KKeyEdit("ǉ");
       		} else if (item.equals(sc.siCopy)) {
       			sc.pos = 5;
       			kke = new KKeyEdit("VKǉ");
        	}        		
   	   		kke.addCommand(exitCommand);
   			kke.addCommand(canCommand);
   			kke.setCommandListener(this);
   			disp.setCurrent(kke);
        }
	}
*/
// LECMTE
	
    public void commandAction(Command command, Displayable screen) {
    	if (screen.equals(mainList)) {
    		if (List.SELECT_COMMAND == command) {
    			switch (((List)screen).getSelectedIndex()) {
    				case 0 : 
    					fsel.refresh(); 
    					disp.setCurrent(fsel.fontForm); 
    					break;
    				case 1 :
    					ts.refresh();
    					disp.setCurrent(ts.textForm);
    					break;
    				case 2 :
// LECMTS
/*
    					udic.refresh();
    					disp.setCurrent(udic.udicForm);
    					break;
    				case 3 :
*/
// LECMTE
    					tbmenu.refresh();
    					disp.setCurrent(tbmenu.tbForm);
    					break;
    				case 3 :		// LEMOD
    					kjmenu.refresh();
    					disp.setCurrent(kjmenu.kjForm);
    					break;
    				case 4 :		// LEMOD
    					imode.refresh();
    					disp.setCurrent(imode.imForm);
    					break;
// LECMTS
/*
    				case 6 :
    					sc.refresh();
    					disp.setCurrent(sc.scForm);
    					break;
*/
// LECMTE
    				case 5 :		// LEMOD
    					osel.refresh();
    					disp.setCurrent(osel.otherForm);
    					break;
// LECMTS
/*
    				case 8 :
    					e61key.refresh();
    					disp.setCurrent(e61key.e61Form);
    					break;
*/
// LECMTE
    			}
    		}
	        if (command == exitCommand) {
	        	storeConfig();
// LECMTS
/*
	        	storeShortCut();
*/
// LECMTE
    	        destroyApp(false);
        	    notifyDestroyed();
        	} else if (command == canCommand) {
    	        destroyApp(false);
        	    notifyDestroyed();
        	}
        } else if (screen.equals(fsel.fontForm)) {
        	if (command == exitCommand) fsel.saveConfig();
			disp.setCurrent(mainList);
        } else if (screen.equals(ts.textForm)) {
        	if (command == exitCommand) ts.saveConfig();
        	disp.setCurrent(mainList);
// LECMTS
/*
        } else if (screen.equals(udic.udicForm)) {
        	if (command == exitCommand) udic.saveConfig();
        	disp.setCurrent(mainList);
*/
// LECMTE
        } else if (screen.equals(tbmenu.tbForm)) {
        	if (command == exitCommand) tbmenu.saveConfig();
        	disp.setCurrent(mainList);
        } else if (screen.equals(kjmenu.kjForm)) {
        	if (command == exitCommand) kjmenu.saveConfig();
        	disp.setCurrent(mainList);
        } else if (screen.equals(imode.imForm)) {
        	if (command == exitCommand) imode.saveConfig();
        	disp.setCurrent(mainList);
        } else if (screen.equals(osel.otherForm)) {
        	if (command == exitCommand) osel.saveConfig();
        	disp.setCurrent(mainList);
// LECMTS
/*
        } else if (screen.equals(e61key.e61Form)) {
        	if (command == exitCommand) e61key.saveConfig();
        	disp.setCurrent(mainList);
        } else if (screen.equals(sc.scForm)) {
        	if (command == exitCommand) sc.saveConfig();
        	disp.setCurrent(mainList);
        } else if (screen.equals(kke)) {
        	if (command == exitCommand) sc.setValue(kke.key);
        	disp.setCurrent(sc.scForm);
        } else if (screen.equals(kfd.fileList)) {
			if (List.SELECT_COMMAND == command) {
   				new Thread(new Runnable() {
   					public void run() {
   						kfd.openNext();
   					}
   				}).start();
			} else if (command == exitCommand) {
				String path = kfd.getPathName();
				if (!(path.endsWith("/") || path.endsWith(".."))) {
					udic.setPathName(path);
					disp.setCurrent(udic.udicForm);
				}
			} else disp.setCurrent(udic.udicForm);
*/
// LECMTE
		}
    }
    
    // Automatic Text Save Option
    protected class TextSave
    {
    	public Form textForm;
    	private ChoiceGroup cgTxt;
    	
    	public TextSave() {
    		if (bTextSave < 0 || bTextSave > 1) bTextSave = 0;
    		textForm = new Form("eLXgۊ");
    		String[] sa = {"YES", "NO"};
    		Image[] ia = null;
    		cgTxt = new ChoiceGroup("KKJConvIɃeLXg̎ۊǂs܂?", ChoiceGroup.EXCLUSIVE, sa, ia);
			textForm.append(cgTxt);
    		refresh();
    	}
    	
    	public void refresh() {
    		cgTxt.setSelectedIndex(bTextSave, true);
    	}
    	
    	public void saveConfig() {
    		bTextSave = (byte)cgTxt.getSelectedIndex();
    	}
    }
    
    // Font Selection Panel
    protected class FontSel
    {
    	public Form fontForm;
    	private ChoiceGroup cgKj, cgSp;
    	
    	public FontSel() {
    		if (bKJFont < 0 || bKJFont > 2) bKJFont = 0;
    		if (bSPFont < 0 || bSPFont > 2) bSPFont = 0;
    		fontForm = new Form("tHg̑I");
    		String[] sa = {"", "", ""};
    		Image[] ia = null;
    		cgKj = new ChoiceGroup("͉", ChoiceGroup.EXCLUSIVE, sa, ia);
    		cgSp = new ChoiceGroup("L̓pl", ChoiceGroup.EXCLUSIVE, sa, ia);
            fontForm.append(cgKj);
			fontForm.append(cgSp);
			refresh();
    	}
    	
    	public void refresh() {
    		cgKj.setSelectedIndex(bKJFont, true);
    		cgSp.setSelectedIndex(bSPFont, true);
    	}
    	
    	public void saveConfig() {
    		bKJFont = (byte)cgKj.getSelectedIndex();
    		bSPFont = (byte)cgSp.getSelectedIndex();
    	}
    }
    
// LECMTS
/*
    protected class UserDict
    {
    	public Form udicForm;
    	public StringItem siUdicPath;
    	private ChoiceGroup cgUdic;
    	private TextField tfUdicPath;
    	int iUdic;
    	
    	public UserDict() {
    		udicForm = new Form("[U[");
    		String [] sa = {"YES", "NO"};
    		Image[] ia = null;
    		cgUdic = new ChoiceGroup("[U[gp܂H", ChoiceGroup.EXCLUSIVE, sa, ia);
    		tfUdicPath = new TextField("[U[̏ꏊ", "", 50, TextField.ANY);
	   		siUdicPath = new StringItem("[U[Qƃ{^", "KKJUser.dic̏ꏊw肵܂", Item.BUTTON);
	   		udicForm.append(cgUdic);
    		udicForm.append(siUdicPath);
    		udicForm.append(tfUdicPath);
    	}

    	public void setPathName(String name) {
    		tfUdicPath.setString(name);
    	}
    	
    	public void refresh() {
    		iUdic = (0 == bUserDict) ? 1 : 0;
    		cgUdic.setSelectedIndex(iUdic, true);
    		tfUdicPath.setString(sUserDictPath);
    	}
    	
    	public void saveConfig() {
    		bUserDict = (byte)((0 == cgUdic.getSelectedIndex()) ? 1 : 0);
    		sUserDictPath = tfUdicPath.getString();
    	}
    }

	protected class ShortCut
	{
		public Form scForm;
		public StringItem siKanji, siCopy, siSpChr, siIns, siAdd;
		public StringItem siMode, siDefault;
		public int pos, k0, k1, k2, k3, k4, k5;
		
		public ShortCut() {
			scForm = new Form("V[gJbg`");
			siSpChr   = new StringItem("Lpl", "", Item.BUTTON);
			siKanji   = new StringItem("[h", "", Item.BUTTON);
			siKanji.setLayout(Item.LAYOUT_NEWLINE_BEFORE);
			siMode    = new StringItem("@@", "", Item.BUTTON);
			siMode.setLayout(Item.LAYOUT_NEWLINE_BEFORE);
			siIns     = new StringItem("}@@@", "", Item.BUTTON);
			siIns.setLayout(Item.LAYOUT_NEWLINE_BEFORE);
			siAdd     = new StringItem("ǉ@@@", "", Item.BUTTON);
			siAdd.setLayout(Item.LAYOUT_NEWLINE_BEFORE);
			siCopy    = new StringItem("VKǉ@", "", Item.BUTTON);
			siCopy.setLayout(Item.LAYOUT_NEWLINE_BEFORE);
			siDefault = new StringItem("Default", "Klɖ߂", Item.BUTTON);
			siDefault.setLayout(Item.LAYOUT_NEWLINE_BEFORE);
			scForm.append(siSpChr);
			scForm.append(siKanji);
			scForm.append(siMode);
			scForm.append(siIns);
			scForm.append(siAdd);
			scForm.append(siCopy);
			scForm.append(siDefault);
			refresh();
		}

		public void setDefault() {
			siSpChr.setText(KKeyEdit.keyName(k0 = 0x2f));
			siKanji.setText(KKeyEdit.keyName(k1 = 11));
			siMode.setText(KKeyEdit.keyName(k2 = 24));
			siIns.setText(KKeyEdit.keyName(k3 = 9));
			siAdd.setText(KKeyEdit.keyName(k4 = 1));
			siCopy.setText(KKeyEdit.keyName(k5 = 3));
		}
		
		public void setDefaultValue() {
    		iSpChr = 0x2f;	// '/'
    		iKJModeKey = 11;	// Ctr+K;
	    	iModeKey = 24;	// Ctr+X
	    	iInsKey = 9;	// Ctr+I
    		iAddKey = 1;	// Ctr+A
    		iCopyKey = 3;	// Ctr+C
		}

		public void refresh() {
			siSpChr.setText(KKeyEdit.keyName(k0 = iSpChr));
			siKanji.setText(KKeyEdit.keyName(k1 = iKJModeKey));
			siMode.setText(KKeyEdit.keyName(k2 = iModeKey));
			siIns.setText(KKeyEdit.keyName(k3 = iInsKey));
			siAdd.setText(KKeyEdit.keyName(k4 = iAddKey));
			siCopy.setText(KKeyEdit.keyName(k5 = iCopyKey));
		}
		
		public void setValue(int k) {
			switch (pos) {
				case 0 : k0 = k; siSpChr.setText(KKeyEdit.keyName(k)); break;
				case 1 : k1 = k; siKanji.setText(KKeyEdit.keyName(k)); break;
				case 2 : k2 = k; siMode.setText(KKeyEdit.keyName(k)); break;
				case 3 : k3 = k; siIns.setText(KKeyEdit.keyName(k)); break;
				case 4 : k4 = k; siAdd.setText(KKeyEdit.keyName(k)); break;
				case 5 : k5 = k; siCopy.setText(KKeyEdit.keyName(k)); break;
			}
		}

		public void saveConfig() {
			iSpChr = k0;
			iKJModeKey = k1;
			iModeKey = k2;
			iInsKey = k3;
			iAddKey = k4;
			iCopyKey = k5;
		}
    }
*/
// LECMTE
    
    // Other selection
    protected class OtherSel
    {
    	public Form otherForm;
    	private ChoiceGroup cgFreedom, cgListConv, cgMemDic;
    	private int iFreedom, iListConv, iMemDic;
    	
    	public OtherSel() {
    		otherForm = new Form("̑̐ݒ");
    		String[] sa = {"", ""};
    		Image[] ia = null;
    		cgListConv = new ChoiceGroup("ϊ̃Xg\", ChoiceGroup.EXCLUSIVE, sa, ia);
    		otherForm.append(cgListConv);
// LECMTS
/*
    		cgFreedom = new ChoiceGroup("Freedom Mini + Nokia Driver pL[R[hϊ", ChoiceGroup.EXCLUSIVE, sa, ia);
    		otherForm.append(cgFreedom);
*/
// LECMTE
    		cgMemDic = new ChoiceGroup("̃[Ǎ", ChoiceGroup.EXCLUSIVE, sa, ia);
    		otherForm.append(cgMemDic);
    		refresh();
    	}
    	
    	public void refresh() {
    		iListConv = (0 == bListConv) ? 0 : 1;
    		cgListConv.setSelectedIndex(iListConv, true);
// LECMTS
/*
    		iFreedom = (0 == (0x01 & bOtherFlag)) ? 0 : 1;
    		cgFreedom.setSelectedIndex(iFreedom, true);
*/
// LECMTE
    		iMemDic = (0 == (0x02 & bOtherFlag)) ? 0 : 1;
    		cgMemDic.setSelectedIndex(iMemDic, true);
    	}
    	
    	public void saveConfig() {
    		bListConv = (byte)((0 == cgListConv.getSelectedIndex()) ? 0 : 3);
    		bOtherFlag = 0;
// LECMTS
/*
    		if (0 != cgFreedom.getSelectedIndex()) bOtherFlag |= 0x01;
*/
// LECMTE
    		if (0 != cgMemDic.getSelectedIndex()) bOtherFlag |= 0x02;
    	}
    }
    
    protected class TbMenu
    {
    	public Form tbForm;
    	public ChoiceGroup cgTb;
    	
    	public TbMenu() {
    		tbForm = new Form("Rsyʃj[");
    		String[] sa = {"", "NA[", "Cache Status", "Cache Print"};
    		Image[] ia = null;
    		cgTb = new ChoiceGroup("Rsyʃj[I", ChoiceGroup.MULTIPLE, sa, ia);
    		tbForm.append(cgTb);
    		refresh();
    	}
    	
    	public void refresh() {
    		cgTb.setSelectedIndex(0, 0 == (0x01 & bTbMenuItem));
    		cgTb.setSelectedIndex(1, 0 == (0x02 & bTbMenuItem));
    		cgTb.setSelectedIndex(2, 0 == (0x04 & bTbMenuItem));
    		cgTb.setSelectedIndex(3, 0 == (0x08 & bTbMenuItem));
    	}
    	
    	public void saveConfig() {
    		bTbMenuItem = 0;
    		if (!cgTb.isSelected(0)) bTbMenuItem |= 0x01;
    		if (!cgTb.isSelected(1)) bTbMenuItem |= 0x02;
    		if (!cgTb.isSelected(2)) bTbMenuItem |= 0x04;
    		if (!cgTb.isSelected(3)) bTbMenuItem |= 0x08;
    	}
    }
    
    protected class KjMenu
    {
    	public Form kjForm;
    	public ChoiceGroup cgKj;
    	
    	public KjMenu() {
    		kjForm = new Form("̓j[");
    		// LECMOD
//    		String[] sa = {"Lpl", "ؑ", "}", "ǉ", "VKǉ", "t@Cۊ", "t@CǍ"};
    		String[] sa = {"Lpl", "ؑ", "}", "ǉ", "VKǉ"};
    		Image[] ia = null;
    		cgKj = new ChoiceGroup("̓j[I", Choice.MULTIPLE, sa, ia);
    		kjForm.append(cgKj);
    		refresh();
    	}
    	
    	public void refresh() {
    		cgKj.setSelectedIndex(0, 0 == (0x01 & bKjMenuItem));
    		cgKj.setSelectedIndex(1, 0 == (0x02 & bKjMenuItem));
    		cgKj.setSelectedIndex(2, 0 == (0x04 & bKjMenuItem));
    		cgKj.setSelectedIndex(3, 0 == (0x08 & bKjMenuItem));
    		cgKj.setSelectedIndex(4, 0 == (0x10 & bKjMenuItem));
// LECMTS
/*
    		cgKj.setSelectedIndex(5, 0 == (0x20 & bKjMenuItem));
    		cgKj.setSelectedIndex(6, 0 == (0x40 & bKjMenuItem));
*/
// LECMTE
    	}
    	
    	public void saveConfig() {
    		bKjMenuItem = 0;
    		if (!cgKj.isSelected(0)) bKjMenuItem |= 0x01;
    		if (!cgKj.isSelected(1)) bKjMenuItem |= 0x02;
    		if (!cgKj.isSelected(2)) bKjMenuItem |= 0x04;
    		if (!cgKj.isSelected(3)) bKjMenuItem |= 0x08;
    		if (!cgKj.isSelected(4)) bKjMenuItem |= 0x10;
// LECMTS
/*
    		if (!cgKj.isSelected(5)) bKjMenuItem |= 0x20;
    		if (!cgKj.isSelected(6)) bKjMenuItem |= 0x40;
*/
// LECMTE
    	}
    }
    
    protected class IModeMenu
    {
    	public Form imForm;
    	public ChoiceGroup cgIm;
    	
    	public IModeMenu() {
    		imForm = new Form("");
    		String[] sa;
// LECMTS
/*
    		if (bE61) {
	    		sa = new String[] {"Sp", "p", "SJi", "Ji", "SL", "L"};
	    	} else {
*/
// LECMTE
	    		sa = new String[] {"Sp", "p", "SJi", "Ji"};
// LECMTS
/*
	    	}
*/
// LECMTE
    		Image[] ia = null;
    		cgIm = new ChoiceGroup("I", Choice.MULTIPLE, sa, ia);
    		imForm.append(cgIm);
    		refresh();
    	}
    	
    	public void refresh() {
    		cgIm.setSelectedIndex(0, 0 == (0x01 & bIMode));
    		cgIm.setSelectedIndex(1, 0 == (0x02 & bIMode));
    		cgIm.setSelectedIndex(2, 0 == (0x04 & bIMode));
    		cgIm.setSelectedIndex(3, 0 == (0x08 & bIMode));
// LECMTS
/*
    		if (bE61) {
	    		cgIm.setSelectedIndex(4, 0 == (0x10 & bIMode));
    			cgIm.setSelectedIndex(5, 0 == (0x20 & bIMode));
    		}
*/
// LECMTE
    	}
    	
    	public void saveConfig() {
    		bIMode = 0;
    		if (!cgIm.isSelected(0)) bIMode |= 0x01;
    		if (!cgIm.isSelected(1)) bIMode |= 0x02;
    		if (!cgIm.isSelected(2)) bIMode |= 0x04;
    		if (!cgIm.isSelected(3)) bIMode |= 0x08;
// LECMTS
/*
    		if (bE61) {
	    		if (!cgIm.isSelected(4)) bIMode |= 0x10;
    			if (!cgIm.isSelected(5)) bIMode |= 0x20;
    		}
*/
// LECMTE
    	}
    }

// LECMTS
/*
    protected class E61KeyTop
    {
    	public Form e61Form;
    	private ChoiceGroup cgE61;
    	private int iE61key;
    	
    	public E61KeyTop() {
    		e61Form = new Form("E61L[CAEg");
    		String[] sa = {"@[!][&][-][1][2][3][*][/][=][?]", "@[!][\"][&][1][2][3][*][-][+][=]", "[!][\"][&][1][2][3][*][-][+][=]", "@[!][\"][-][1][2][3][*][+][=][?]", "[ ][ ][ ][1][2][3][*][ ][ ][ ]"};
    		Image[] ia = null;
    		cgE61 = new ChoiceGroup("E61LL[̑I", ChoiceGroup.EXCLUSIVE, sa, ia);
    		e61Form.append(cgE61);
    		refresh();
    	}
    	
    	public void refresh() {
    		iE61key = bE61key - 1;
    		if (0 > iE61key || iE61key > 4) iE61key = 0;
    		cgE61.setSelectedIndex(iE61key, true);
    	}
    	
    	public void saveConfig() {
    		bE61key = (byte)(cgE61.getSelectedIndex() + 1);
    	}
    }
*/
// LECMTE
}
